<urbo-cms-ui-table
  [data]="users"
  [columns]="columns"
  [paginator]="true"
  [rows]="10"
  [lazy]="false"
  [rowsPerPageOptions]="[10, 25, 50]"
  [totalRecords]="users.length"
  [customActionTemplate]="resetPasswordAction"
  (createButtonClick)="navigateToCreateUser()"
  [createPermission]="Permission.Administration"
  (edit)="editUser($event)"
  [editPermission]="Permission.Administration"
  (delete)="deleteUser($event)"
  [deletePermission]="Permission.Administration"
></urbo-cms-ui-table>

<ng-template #resetPasswordAction let-user>
  <button
    pButton
    pRipple
    icon="pi pi-envelope"
    class="p-button-rounded p-button-warning m-1"
    (click)="confirmResetPassword(user)"
  ></button>
</ng-template>

<p-dialog
  [(visible)]="resetPasswordDialog"
  header="Passwort zurücksetzen"
  [modal]="true"
  [style]="{ width: '450px' }"
>
  <div class="flex align-items-center justify-content-center">
    <i class="pi pi-exclamation-triangle mr-3" style="font-size: 2rem"></i>
    <span
      >Willst du wirklich eine E-Mail zum Zurücksetzen des Passworts an
      {{ selectedUser?.firstName }} {{ selectedUser?.lastName }} senden?</span
    >
  </div>
  <ng-template pTemplate="footer">
    <button
      pButton
      pRipple
      icon="pi pi-times"
      class="p-button-text"
      label="Nein"
      (click)="resetPasswordDialog = false"
    ></button>
    <button
      pButton
      pRipple
      icon="pi pi-check"
      class="p-button-text"
      label="Ja"
      (click)="resetPassword()"
    ></button>
  </ng-template>
</p-dialog>

<p-dialog
  [(visible)]="userDialog"
  [modal]="true"
  header="User Details"
  [style]="{ width: '450px' }"
  (onHide)="hideDialog()"
  class="p-fluid"
>
  <div *ngIf="selectedUser">
    <div class="field">
      <label for="firstName">Vorname</label>
      <input
        type="text"
        id="firstName"
        [(ngModel)]="selectedUser.firstName"
        pInputText
      />
    </div>
    <div class="field">
      <label for="lastName">Nachname</label>
      <input
        type="text"
        id="lastName"
        [(ngModel)]="selectedUser.lastName"
        pInputText
      />
    </div>
    <div class="field">
      <label for="roles">Rollen</label>
      <p-multiSelect
        id="roles"
        [(ngModel)]="selectedUser.roles"
        [options]="roles"
        optionLabel="name"
        optionValue="name"
        placeholder="Wähle Berechtigungen"
        appendTo="body"
      >
      </p-multiSelect>
    </div>
  </div>
  <ng-template pTemplate="footer">
    <button
      pButton
      pRipple
      label="Abbrechen"
      icon="pi pi-times"
      class="p-button-text"
      (click)="hideDialog()"
    ></button>
    <button
      pButton
      pRipple
      label="Speichern"
      icon="pi pi-check"
      class="p-button-text"
      (click)="saveUser()"
    ></button>
  </ng-template>
</p-dialog>

<p-dialog
  [(visible)]="deleteUserDialog"
  header="Bestätigen"
  [modal]="true"
  [style]="{ width: '450px' }"
>
  <div class="flex align-items-center justify-content-center">
    <i class="pi pi-exclamation-triangle mr-3" style="font-size: 2rem"></i>
    <span>Bist du sicher, dass du diesen Benutzer löschen möchtest?</span>
  </div>
  <ng-template pTemplate="footer">
    <button
      pButton
      pRipple
      icon="pi pi-times"
      class="p-button-text"
      label="Nein"
      (click)="deleteUserDialog = false"
    ></button>
    <button
      pButton
      pRipple
      icon="pi pi-check"
      class="p-button-text"
      label="Ja"
      (click)="confirmDelete()"
    ></button>
  </ng-template>
</p-dialog>
